xref: /haiku/configure (revision 11ae3c5fe78154e4934d0c8c1eb744c9104427b2)
152a38012Sejakowatz#!/bin/sh
252a38012Sejakowatz#
3338b8dc3SIngo Weinhold# configure [ <options> ]
4614026d7Sshatty
539d444a3SArvind S Raj# set flag to exit script when exit command is executed
639d444a3SArvind S Rajset -e
739d444a3SArvind S Raj
8022fa244SIngo Weinhold# usage
9022fa244SIngo Weinhold#
10022fa244SIngo Weinhold# Prints usage.
11022fa244SIngo Weinhold#
12022fa244SIngo Weinholdusage()
13022fa244SIngo Weinhold{
14022fa244SIngo Weinhold	cat << EOF
15022fa244SIngo Weinhold
16022fa244SIngo WeinholdUsage: $0 <options>
17022fa244SIngo Weinholdoptions:
18e173a1ecSIngo Weinhold  --bootstrap <haikuporter> <HaikuPorts cross repo> <HaikuPorts repo>
19e173a1ecSIngo Weinhold                              Prepare for a bootstrap build. No pre-built
20e173a1ecSIngo Weinhold                              packages will be used, instead they will be built
21e173a1ecSIngo Weinhold                              from the sources (in several phases).
22e173a1ecSIngo Weinhold                              <haikuporter> is the path to the haikuporter tool
23e173a1ecSIngo Weinhold                              suitable for the host platform.
24e173a1ecSIngo Weinhold                              <HaikuPorts cross repo> is the path to a checked
25e173a1ecSIngo Weinhold                              out HaikuPorts cross-compilation repository.
26e173a1ecSIngo Weinhold                              <HaikuPorts repo> is the path to a checked out
27e173a1ecSIngo Weinhold                              HaikuPorts repository.
28c0e8cc1aSIngo Weinhold  --build-cross-tools <arch> [ <build tools dir> ]
29338b8dc3SIngo Weinhold                              Assume cross compilation. <build tools dir>
30338b8dc3SIngo Weinhold                              defines the location of the build tools sources.
31338b8dc3SIngo Weinhold                              They will be compiled and placed in the output
32a5b60fa8SOliver Tappe                              directory under "cross-tools". The HAIKU_* tools
33a5b60fa8SOliver Tappe                              variables will be set accordingly.
3420ab75e6SIngo Weinhold                              <arch> specifies the target architecture, either
351b38c341SAlexander von Gluck IV                              "x86_gcc2", "x86", "x86_64", "ppc", "m68k", "arm"
36c0e8cc1aSIngo Weinhold                              This option and --cross-tools-prefix can be
37c0e8cc1aSIngo Weinhold                              specified multiple times. The first cross tools
38c0e8cc1aSIngo Weinhold                              specify the primary tools, the subsequent ones the
39c0e8cc1aSIngo Weinhold                              secondary tools (for "hybrid" images).
40c0e8cc1aSIngo Weinhold                              For the first --build-cross-tools the
41c0e8cc1aSIngo Weinhold                              <build tools dir> argument must be specified and
42c0e8cc1aSIngo Weinhold                              for the subsequent ones it must be omitted.
43eccc7665SIngo Weinhold  --cross-tools-prefix <prefix>
44eccc7665SIngo Weinhold                              Assume cross compilation. <prefix> should be a
45eccc7665SIngo Weinhold                              path to the directory where the cross
46eccc7665SIngo Weinhold                              compilation tools are located, plus the platform
470da9c208SIngo Weinhold                              prefix, e.g. "/path/to/tools/i586-pc-haiku-".
48eccc7665SIngo Weinhold                              This overrides the HAIKU_* tool variables.
49a66c32ddSIngo Weinhold  --distro-compatibility <level>
50a66c32ddSIngo Weinhold                              The distribution's level of compatibility with
51a66c32ddSIngo Weinhold                              the official Haiku distribution. The generated
52a66c32ddSIngo Weinhold                              files will contain the respective trademarks
53a66c32ddSIngo Weinhold                              accordingly.
54a66c32ddSIngo Weinhold                              official -- the official Haiku distribution.
55a66c32ddSIngo Weinhold                              compatible -- a Haiku Compatible (tm) distro.
56a66c32ddSIngo Weinhold                              default -- any other distro (default value).
5760d8d8fcSIngo Weinhold  --enable-multiuser          Enable experimental multiuser support.
58eccc7665SIngo Weinhold  --help                      Prints out this help.
592ebcd86dSIngo Weinhold  --host-only                 Configure for building tools for the build host
602ebcd86dSIngo Weinhold                              only. Haiku cannot be built when configured like
612ebcd86dSIngo Weinhold                              this.
62eccc7665SIngo Weinhold  --include-gpl-addons        Include GPL licensed add-ons.
6367838392SAxel Dörfler  --include-patented-code     Enable code that is known to implemented patented
6467838392SAxel Dörfler                              ideas and techniques. If this option is not
6567838392SAxel Dörfler                              specified, the resulting distribution may still
6667838392SAxel Dörfler                              implement patented ideas and techniques. This
6767838392SAxel Dörfler                              option only disables code that is currently known
6867838392SAxel Dörfler                              to be problematic.
6976fa0be3SIngo Weinhold  --include-sources           Includes the source code of projects that require
7076fa0be3SIngo Weinhold                              either an offer of source code or a copy of the
7176fa0be3SIngo Weinhold                              patched sources. This is preferable when
7276fa0be3SIngo Weinhold                              distributing on physical mediums.
731974210fSFrançois Revol  --include-3rdparty          Include 3rdparty/ in the build system.
744880ae01SJessica Hamilton  -j<n>                       Only relevant for --build-cross-tools. Is passed
754880ae01SJessica Hamilton                              on to the make building the build tools.
76aa2e5ecaSOliver Tappe  --no-downloads              Do not download anything. Useful when trying to
77aa2e5ecaSOliver Tappe                              bootstrap and build Haiku from source only.
7886d7e283SOliver Tappe  --remote-user <username>    Use given username when logging into
7986d7e283SOliver Tappe                              git.haiku-os.org (via ssh).
807c4641d0SOliver Tappe  --target=TARGET             Select build target platform.
817c4641d0SOliver Tappe                              [default=${TARGET_PLATFORM}]
82a17b9c0cSshatty                              valid targets=r5,bone,dano,haiku
83483b28e4SIngo Weinhold  --target-arch <arch>        Haiku only: Specify the target architecture to
84483b28e4SIngo Weinhold                              build for. Must be one of the architectures of the
85483b28e4SIngo Weinhold                              host system. The installed build tools for that
86483b28e4SIngo Weinhold                              architecture will be used.
87483b28e4SIngo Weinhold                              This option can be specified multiple times. The
88483b28e4SIngo Weinhold                              first occurrence specifies the primary
89483b28e4SIngo Weinhold                              architecture of the Haiku to build, subsequent
90483b28e4SIngo Weinhold                              ones the secondary architectures.
91e70c4c64SPulkoMandy  --target-board <board>      ARM only: Specify the board to build for. Must be
92c0b833b1SAlexander von Gluck IV                              one of beagle,raspberry_pi,verdex.
937c4641d0SOliver Tappe  --update                    re-runs last configure invocation [must be given
947c4641d0SOliver Tappe                              as first option!]
95c2b76f7fSJonathan Schleifer  --use-clang                 Build with host Clang instead of GCC cross
96c2b76f7fSJonathan Schleifer                              compiler
97eccc7665SIngo Weinhold  --use-gcc-pipe              Build with GCC option -pipe. Speeds up the build
985a34a443SFrançois Revol                              process, but uses more memory.
99ed38d2efSJerome Duval  --use-gcc-graphite          Build with GCC Graphite engine for loop
100ed38d2efSJerome Duval                              optimizations. Only for gcc 4.
1010385b065SIngo Weinhold  --use-32bit                 Use -m32 flag on 64bit host gcc compiler.
102bc96e8f3SIngo Weinhold  --use-xattr                 Use Linux xattr respectively *BSD extattr support
103bc96e8f3SIngo Weinhold                              for BeOS attribute emulation. Warning: Make sure
104bc96e8f3SIngo Weinhold                              your file system supports sufficient attribute
105bc96e8f3SIngo Weinhold                              sizes (4 KB per file for all attributes won't
106bc96e8f3SIngo Weinhold                              suffice).
107bc96e8f3SIngo Weinhold  --use-xattr-ref             Use the generic BeOS attribute emulation, but use
108bc96e8f3SIngo Weinhold                              Linux xattr respectively *BSD extattr support to
109bc96e8f3SIngo Weinhold                              make it more robust (i.e. attribute mix-ups become
110bc96e8f3SIngo Weinhold                              less likely).
111338b8dc3SIngo Weinhold
112338b8dc3SIngo Weinholdenvironment variables:
11363701e7dSOliver Tappe  CC                          The host compiler. Defaults to "gcc".
114c0e8cc1aSIngo Weinhold  HAIKU_AR_x86_gcc2           The static library archiver for x86_gcc2.
115c0e8cc1aSIngo Weinhold                              Defaults to "ar".
116c0e8cc1aSIngo Weinhold  HAIKU_CC_x86_gcc2           The x86_gcc2 compiler. Defaults to "gcc".
117c0e8cc1aSIngo Weinhold  HAIKU_LD_x86_gcc2           The x86_gcc2 linker. Defaults to "ld".
118c0e8cc1aSIngo Weinhold  HAIKU_OBJCOPY_x86_gcc2      The x86_gcc2 objcopy to be used. Defaults to
119c0e8cc1aSIngo Weinhold                              "objcopy".
120c0e8cc1aSIngo Weinhold  HAIKU_RANLIB_x86_gcc2       The static library indexer for x86_gcc2. Defaults
121c0e8cc1aSIngo Weinhold                              to "ranlib".
122c0e8cc1aSIngo Weinhold  HAIKU_STRIP_x86_gcc2        The x86_gcc2 strip command. Defaults to "strip".
123a04a520bSJonathan Schleifer  HAIKU_NASM                  The nasm assembler (x86 and x86_64 only).
124c0e8cc1aSIngo Weinhold  HAIKU_CPPFLAGS_<arch>       The preprocessor flags for target architecture
125c0e8cc1aSIngo Weinhold                              <arch>. Defaults to "".
126c0e8cc1aSIngo Weinhold  HAIKU_CCFLAGS_<arch>        The C flags for target architecture <arch>.
127c0e8cc1aSIngo Weinhold                              Defaults to "".
128c0e8cc1aSIngo Weinhold  HAIKU_CXXFLAGS_<arch>       The C++ flags for target architecture <arch>.
129c0e8cc1aSIngo Weinhold                              Defaults to "".
130c0e8cc1aSIngo Weinhold  HAIKU_LDFLAGS_<arch>        The linker flags for target architecture <arch>.
131c0e8cc1aSIngo Weinhold                              Defaults to "".
132c0e8cc1aSIngo Weinhold  HAIKU_ARFLAGS_<arch>        The flags passed to HAIKU_AR for target
133c0e8cc1aSIngo Weinhold                              architecture <arch> for archiving. Defaults to
134c0e8cc1aSIngo Weinhold                              "cru".
135c0e8cc1aSIngo Weinhold  HAIKU_UNARFLAGS_<arch>      The flags passed to HAIKU_AR for target
136c0e8cc1aSIngo Weinhold                              architecture <arch> for unarchiving. Defaults to
137c0e8cc1aSIngo Weinhold                              "x".
13864f6da31SIngo Weinhold
139c0e8cc1aSIngo WeinholdNon-default output directories:
14064f6da31SIngo Weinhold  By default all objects, build configuration, and other related files are
14164f6da31SIngo Weinhold  stored in /path/to/haiku_source/generated.  To store objects in a non-default
14264f6da31SIngo Weinhold  location, run "../../relative/path/to/haiku_source/configure <options>" from
14364f6da31SIngo Weinhold  within your non-default location.  "jam [ options ] targets" can then be run
14464f6da31SIngo Weinhold  directly inside your non-default location.  Another option is to invoke "jam
14564f6da31SIngo Weinhold  [ options ] targets" from within haiku_source.  This can be accomplished by
14664f6da31SIngo Weinhold  either "export HAIKU_OUTPUT_DIR=your non-default location" before invoking
14764f6da31SIngo Weinhold  jam or by creating a symlink of haiku_source/generated pointing to your
14864f6da31SIngo Weinhold  non-default location and running jam.
14964f6da31SIngo Weinhold
15064f6da31SIngo Weinhold
151022fa244SIngo WeinholdEOF
152022fa244SIngo Weinhold}
153022fa244SIngo Weinhold
154022fa244SIngo Weinhold# assertparam
155022fa244SIngo Weinhold#
156022fa244SIngo Weinhold# Checks whether at least one parameter is left.
157022fa244SIngo Weinhold#
158022fa244SIngo Weinholdassertparam()
159022fa244SIngo Weinhold{
16020ab75e6SIngo Weinhold	if [ $2 -lt 2 ]; then
161022fa244SIngo Weinhold		echo $0: \`$1\': Parameter expected.
162022fa244SIngo Weinhold		exit 1
163022fa244SIngo Weinhold	fi
164022fa244SIngo Weinhold}
165022fa244SIngo Weinhold
16620ab75e6SIngo Weinhold# assertparams
16720ab75e6SIngo Weinhold#
16820ab75e6SIngo Weinhold# Checks whether at least a certain number of parameters is left.
16920ab75e6SIngo Weinhold#
17020ab75e6SIngo Weinholdassertparams()
17120ab75e6SIngo Weinhold{
17220ab75e6SIngo Weinhold	if [ $3 -le $2 ]; then
17320ab75e6SIngo Weinhold		echo $0: \`$1\': Not enough parameters.
17420ab75e6SIngo Weinhold		exit 1
17520ab75e6SIngo Weinhold	fi
17620ab75e6SIngo Weinhold}
17720ab75e6SIngo Weinhold
178e173a1ecSIngo Weinhold# absolute_path
179e173a1ecSIngo Weinhold#
180e173a1ecSIngo Weinhold# returns the absolute path of a given path.
181e173a1ecSIngo Weinhold#
182e173a1ecSIngo Weinholdabsolute_path()
183e173a1ecSIngo Weinhold{
1846a4f3954SFrançois Revol	if [ "x$1" != "x${1#/}" ]; then
185e173a1ecSIngo Weinhold		echo "$1"
186e173a1ecSIngo Weinhold	else
187e173a1ecSIngo Weinhold		echo "`pwd`/$1"
188e173a1ecSIngo Weinhold	fi
189e173a1ecSIngo Weinhold}
190e173a1ecSIngo Weinhold
19139d444a3SArvind S Raj# check_dir_exists
19239d444a3SArvind S Raj#
19339d444a3SArvind S Raj# check if a directory exists or not
19439d444a3SArvind S Raj#
19539d444a3SArvind S Rajcheck_dir_exists()
19639d444a3SArvind S Raj{
19739d444a3SArvind S Raj	if [ -d "$1" ]; then
19839d444a3SArvind S Raj		return 0
19939d444a3SArvind S Raj	else
20039d444a3SArvind S Raj		return 1
20139d444a3SArvind S Raj	fi
20239d444a3SArvind S Raj}
20339d444a3SArvind S Raj
204502882dbSJessica Hamilton# check_file_exists
205502882dbSJessica Hamilton#
206502882dbSJessica Hamilton# check if a file exists or not
207502882dbSJessica Hamilton#
208502882dbSJessica Hamiltoncheck_file_exists()
209502882dbSJessica Hamilton{
210502882dbSJessica Hamilton	if [ -f "$1" ]; then
211502882dbSJessica Hamilton		return 0
212502882dbSJessica Hamilton	else
213502882dbSJessica Hamilton		return 1
214502882dbSJessica Hamilton	fi
215502882dbSJessica Hamilton}
216502882dbSJessica Hamilton
2179a001156SOliver Tappe# real_path
2189a001156SOliver Tappe#
2199a001156SOliver Tappe# returns the realpath of a symbolic link.
2209a001156SOliver Tappe#
2219a001156SOliver Tappereal_path()
2229a001156SOliver Tappe{
2239a001156SOliver Tappe	perl -MCwd=realpath -e'print realpath($ARGV[0]), "\n"' "$1"
2249a001156SOliver Tappe}
2259a001156SOliver Tappe
22609c5682dSIngo Weinhold# standard_gcc_settings
22709c5682dSIngo Weinhold#
22809c5682dSIngo Weinhold# Sets the variables for a GCC platform.
22909c5682dSIngo Weinhold#
23009c5682dSIngo Weinholdstandard_gcc_settings()
23109c5682dSIngo Weinhold{
232c0e8cc1aSIngo Weinhold	local gcc=$1
233c0e8cc1aSIngo Weinhold
234138f5fb4SIngo Weinhold	if which greadlink > /dev/null 2>&1; then
235b29b48b1SMatt Madia		readlink="greadlink -e"
236138f5fb4SIngo Weinhold	elif which realpath > /dev/null 2>&1; then
237b29b48b1SMatt Madia		readlink=realpath
2389a001156SOliver Tappe	elif readlink -e / > /dev/null 2>&1; then
239b29b48b1SMatt Madia		readlink="readlink -e"
2409a001156SOliver Tappe	else
2419a001156SOliver Tappe		readlink=real_path
242b4b6d83cSMatt Madia	fi
243138f5fb4SIngo Weinhold
24409c5682dSIngo Weinhold	# PLATFORM_LINKLIBS
245c0e8cc1aSIngo Weinhold	local gcclib=`$gcc -print-libgcc-file-name`
246c0e8cc1aSIngo Weinhold	local gccdir=`dirname ${gcclib}`
2475b0f7b1bSOliver Tappe
248c0e8cc1aSIngo Weinhold	local gccRawVersion=`$gcc -dumpversion`
249c0e8cc1aSIngo Weinhold	local gccMachine=`$gcc -dumpmachine`
250338b8dc3SIngo Weinhold
251fc8967f1SIngo Weinhold	# determine architecture from machine triple
252c0e8cc1aSIngo Weinhold	case $gccMachine in
253c0e8cc1aSIngo Weinhold		arm-*)		targetCpu=arm;;
254c0e8cc1aSIngo Weinhold		i?86-*)		targetCpu=x86;;
255c0e8cc1aSIngo Weinhold		m68k-*)		targetCpu=m68k;;
256c0e8cc1aSIngo Weinhold		powerpc-*)	targetCpu=ppc;;
257c0e8cc1aSIngo Weinhold		x86_64-*)	targetCpu=x86_64;;
258fc8967f1SIngo Weinhold		*)
259c0e8cc1aSIngo Weinhold			echo "Unsupported gcc target machine: $gccMachine" >&2
260fc8967f1SIngo Weinhold			exit 1
261fc8967f1SIngo Weinhold			;;
262fc8967f1SIngo Weinhold	esac
263fc8967f1SIngo Weinhold
264c0e8cc1aSIngo Weinhold	local targetArch=$targetCpu
265fc8967f1SIngo Weinhold
266c0e8cc1aSIngo Weinhold	case $gccRawVersion in
2676cc8eecfSOliver Tappe		2.9*)
2685b0f7b1bSOliver Tappe			# check for correct (most up-to-date) legacy compiler and complain
2695b0f7b1bSOliver Tappe			# if an older one is installed
270c0e8cc1aSIngo Weinhold			if [ $gccRawVersion != $haikuRequiredLegacyGCCVersion ]; then
2715b0f7b1bSOliver Tappe				echo "GCC version $haikuRequiredLegacyGCCVersion is required!";
2725b0f7b1bSOliver Tappe				echo "Please download it from www.haiku-os.org...";
2735b0f7b1bSOliver Tappe				exit 1;
2745b0f7b1bSOliver Tappe			fi
275aaeadfcbSAlex Smith
276c0e8cc1aSIngo Weinhold			targetArch=x86_gcc2
2775b0f7b1bSOliver Tappe			;;
2788b5934c9SIngo Weinhold	esac
27965ad1ba3SAlex Smith
280c0e8cc1aSIngo Weinhold	local bootLibgcc
281c0e8cc1aSIngo Weinhold	local bootLibSupCxx
28266a7f29fSJérôme Duval	local bootCxxHeaders
283c0e8cc1aSIngo Weinhold	case $gccMachine in
2844591ebc9SAlex Smith		x86_64-*)
28566a7f29fSJérôme Duval			# Boot loader is 32-bit, need the 32-bit libs and c++ config
286*11ae3c5fSOliver Tappe			bootLibgcc=`$gcc -m32 -print-file-name=libgcc.a`
287c0e8cc1aSIngo Weinhold			bootLibSupCxx=`$gcc -m32 -print-file-name=libsupc++.a`
28866a7f29fSJérôme Duval
28966a7f29fSJérôme Duval			local headersBase=$gccdir/../../../..
29066a7f29fSJérôme Duval			local headers=$headersBase/$gccMachine/include/c++/$gccRawVersion
29166a7f29fSJérôme Duval			if [ ! -d $headers ]; then
29266a7f29fSJérôme Duval				headers=$headersBase/include/c++/$gccRawVersion
29366a7f29fSJérôme Duval			fi
29466a7f29fSJérôme Duval			bootCxxHeaders="$headers/$gccMachine/32"
2954591ebc9SAlex Smith			;;
296338b8dc3SIngo Weinhold	esac
297c0e8cc1aSIngo Weinhold
298c0e8cc1aSIngo Weinhold	# determine whether graphite loop optimization should/can be used
299c0e8cc1aSIngo Weinhold	local useGraphite=`get_variable HAIKU_USE_GCC_GRAPHITE_$targetCpu`
300c0e8cc1aSIngo Weinhold	if [ -z "$useGraphite" ]; then
301c0e8cc1aSIngo Weinhold		useGraphite=$useGccGraphiteDefault
302c0e8cc1aSIngo Weinhold	fi
303c0e8cc1aSIngo Weinhold
304c0e8cc1aSIngo Weinhold	if [ "$useGraphite" != 0 ]; then
305c0e8cc1aSIngo Weinhold		UNUSED=`echo "int main() {}" | $gcc -xc -c -floop-block - 2>&1`
306c0e8cc1aSIngo Weinhold		if [ $? != 0 ]; then
307c0e8cc1aSIngo Weinhold			echo "GCC Graphite loop optimizations cannot be used on $targetArch"
308c0e8cc1aSIngo Weinhold			useGraphite=0
309c0e8cc1aSIngo Weinhold		fi
310c0e8cc1aSIngo Weinhold	fi
311c0e8cc1aSIngo Weinhold
312c0e8cc1aSIngo Weinhold	set_variable HAIKU_CPU_$targetArch $targetCpu
313c0e8cc1aSIngo Weinhold
314c0e8cc1aSIngo Weinhold	get_build_tool_path CC_$targetArch "$gcc"
315c2b76f7fSJonathan Schleifer	if [ $useClang = 1 ]; then
316c2b76f7fSJonathan Schleifer		# The get_build_tool_path above is needed to get the path to the rest
317c2b76f7fSJonathan Schleifer		# of the build tools
318c2b76f7fSJonathan Schleifer		local path=`dirname $(get_variable HAIKU_CC_$targetArch)`
319c2b76f7fSJonathan Schleifer		set_variable HAIKU_CC_$targetArch \
320c2b76f7fSJonathan Schleifer			"PATH=\\\"$path:\\\$PATH\\\" clang -target $gccMachine"
321c2b76f7fSJonathan Schleifer		set_variable HAIKU_CC_IS_CLANG_$targetArch 1
322c2b76f7fSJonathan Schleifer	else
323c2b76f7fSJonathan Schleifer		set_variable HAIKU_CC_IS_CLANG_$targetArch 0
324c2b76f7fSJonathan Schleifer	fi
325c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_RAW_VERSION_$targetArch $gccRawVersion
326c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_MACHINE_$targetArch $gccMachine
327c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_LIB_DIR_$targetArch $gccdir
32866a7f29fSJérôme Duval	set_variable HAIKU_BOOT_CXX_HEADERS_DIR_$targetArch "$bootCxxHeaders"
329*11ae3c5fSOliver Tappe	set_variable HAIKU_BOOT_LIBSUPCXX_$targetArch "$bootLibSupCxx"
330*11ae3c5fSOliver Tappe	set_variable HAIKU_BOOT_LIBGCC_$targetArch $bootLibgcc
331c0e8cc1aSIngo Weinhold	set_variable HAIKU_USE_GCC_GRAPHITE_$targetArch $useGraphite
332c0e8cc1aSIngo Weinhold
333c0e8cc1aSIngo Weinhold	standard_gcc_settings_targetArch=$targetArch
334c0e8cc1aSIngo Weinhold}
335c0e8cc1aSIngo Weinhold
336c0e8cc1aSIngo Weinhold# set_variable
337c0e8cc1aSIngo Weinhold#
338c0e8cc1aSIngo Weinhold# Set the value of a variable.
339c0e8cc1aSIngo Weinhold#
340c0e8cc1aSIngo Weinholdset_variable()
341c0e8cc1aSIngo Weinhold{
342c0e8cc1aSIngo Weinhold	eval "$1=\"$2\""
343c0e8cc1aSIngo Weinhold}
344c0e8cc1aSIngo Weinhold
345c0e8cc1aSIngo Weinhold# get_variable
346c0e8cc1aSIngo Weinhold#
347c0e8cc1aSIngo Weinhold# Echo the value of a variable.
348c0e8cc1aSIngo Weinhold#
349c0e8cc1aSIngo Weinholdget_variable()
350c0e8cc1aSIngo Weinhold{
351c0e8cc1aSIngo Weinhold	eval "echo \${$1}"
35209c5682dSIngo Weinhold}
35309c5682dSIngo Weinhold
354338b8dc3SIngo Weinhold# set_default_value
355338b8dc3SIngo Weinhold#
356338b8dc3SIngo Weinhold# Set the value for a variable, if no value is set yet.
357338b8dc3SIngo Weinhold#
358338b8dc3SIngo Weinholdset_default_value()
359338b8dc3SIngo Weinhold{
3600838a930SJérôme Duval	eval "$1=\${$1-$2}"
361338b8dc3SIngo Weinhold}
362338b8dc3SIngo Weinhold
363338b8dc3SIngo Weinhold# get_build_tool_path
364338b8dc3SIngo Weinhold#
365338b8dc3SIngo Weinhold# Gets a usable absolute path of a build tool.
366338b8dc3SIngo Weinhold#
367338b8dc3SIngo Weinholdget_build_tool_path()
368338b8dc3SIngo Weinhold{
369338b8dc3SIngo Weinhold	local var="HAIKU_$1"
370c0e8cc1aSIngo Weinhold	local path=$2
371338b8dc3SIngo Weinhold
372338b8dc3SIngo Weinhold	if [ -f "$path" ]; then
373338b8dc3SIngo Weinhold		# get absolute path
374a559f87aSFrançois Revol		local oldPwd="`pwd`"
375a559f87aSFrançois Revol		cd "`dirname "$path"`"
376a559f87aSFrançois Revol		path="`pwd`/`basename "$path"`"
377338b8dc3SIngo Weinhold		cd $oldPwd
378338b8dc3SIngo Weinhold	else
3797fe2e06cSMatt Madia		which "$path" > /dev/null 2>&1 || {
380338b8dc3SIngo Weinhold			echo "Build tool \"$path\" not found." >&2
381338b8dc3SIngo Weinhold			exit 1
382338b8dc3SIngo Weinhold		}
383338b8dc3SIngo Weinhold	fi
384338b8dc3SIngo Weinhold
385338b8dc3SIngo Weinhold	eval "$var=$path"
386338b8dc3SIngo Weinhold}
387338b8dc3SIngo Weinhold
388483b28e4SIngo Weinholdis_in_list()
389483b28e4SIngo Weinhold{
390483b28e4SIngo Weinhold	local element
391483b28e4SIngo Weinhold	for element in $2; do
392483b28e4SIngo Weinhold		if [ "$1" = "$element" ]; then
393483b28e4SIngo Weinhold			return 0
394483b28e4SIngo Weinhold		fi
395483b28e4SIngo Weinhold	done
396483b28e4SIngo Weinhold	return 1
397483b28e4SIngo Weinhold}
398483b28e4SIngo Weinhold
3998b420c2fSOliver Tappe# check for no params, --help or -h and show usage immediately
4008b420c2fSOliver Tappeif [ -z "$1" ] || [ "$1" = "--help" ] || [ "$1" = "-h" ]; then
4018b420c2fSOliver Tappe	usage; exit 0;
4028b420c2fSOliver Tappefi
4038b420c2fSOliver Tappe
4048b420c2fSOliver Tappe
405338b8dc3SIngo Weinhold# get cwd and the source directory
406338b8dc3SIngo WeinholdcurrentDir=`pwd`
4076e7c6fe5SIngo Weinholdcd `dirname "$0"`
408338b8dc3SIngo WeinholdsourceDir=`pwd`
4096e7c6fe5SIngo Weinholdcd "$currentDir"
410338b8dc3SIngo Weinhold
41155d267a4SFrançois Revol# backup the passed arguments
41255d267a4SFrançois RevolconfigureArgs="$@"
41355d267a4SFrançois Revol
4147c4641d0SOliver Tappe# internal default parameter values
415022fa244SIngo Weinhold#
41652a38012Sejakowatzplatform=`uname`
4175abd9a46SIngo WeinholdplatformMachine=`uname  -m`
418c0e8cc1aSIngo WeinholdtargetArchs=
419338b8dc3SIngo WeinholdbuildCrossTools=
42029ef597dSIngo WeinholdbuildCrossToolsScript="$sourceDir/build/scripts/build_cross_tools"
42160d8d8fcSIngo WeinholdbuildCrossToolsJobs=
422c2b76f7fSJonathan SchleiferuseClang=0
423c0e8cc1aSIngo WeinholduseGccGraphiteDefault=0
424c0e8cc1aSIngo WeinholdunknownArchIndex=1
425483b28e4SIngo WeinholdhaikuTargetArchs=
4267c4641d0SOliver Tappe
42763701e7dSOliver Tappeif [ -z "$CC" ]; then
42863701e7dSOliver Tappe	CC=gcc
42963701e7dSOliver Tappefi
43063701e7dSOliver Tappe
4317c4641d0SOliver Tappe# exported (BuildSetup) default parameter values
4327c4641d0SOliver Tappe#
43363701e7dSOliver TappeHOST_GCC_RAW_VERSION=`$CC -dumpversion`
43463701e7dSOliver TappeHOST_GCC_MACHINE=`$CC -dumpmachine`
4357c4641d0SOliver TappeHAIKU_INCLUDE_GPL_ADDONS=0
4367c4641d0SOliver TappeHAIKU_INCLUDE_PATENTED_CODE=0
43776fa0be3SIngo WeinholdHAIKU_INCLUDE_SOURCES=0
4387c4641d0SOliver TappeHAIKU_INCLUDE_3RDPARTY=0
4397c4641d0SOliver TappeHAIKU_ENABLE_MULTIUSER=0
4407c4641d0SOliver TappeHAIKU_DISTRO_COMPATIBILITY=default
4417c4641d0SOliver TappeTARGET_PLATFORM=haiku
4427c4641d0SOliver TappeHAIKU_USE_GCC_PIPE=0
4437986925fSIngo WeinholdHAIKU_HOST_USE_32BIT=0
4447986925fSIngo WeinholdHAIKU_HOST_USE_XATTR=0
445bc96e8f3SIngo WeinholdHAIKU_HOST_USE_XATTR_REF=0
4462ebcd86dSIngo WeinholdHAIKU_HOST_BUILD_ONLY=0
447f04f7042SNiels Sascha ReedijkHOST_EXTENDED_REGEX_SED="sed -r"
44863701e7dSOliver TappeHOST_GCC_LD=`$CC -print-prog-name=ld`
44963701e7dSOliver TappeHOST_GCC_OBJCOPY=`$CC -print-prog-name=objcopy`
450c505b276SFrançois RevolSFDISK_BINARY=sfdisk
451c505b276SFrançois RevolHOST_SFDISK=$SFDISK_BINARY
4522a5d0aafSIngo WeinholdHOST_SHA256=
453e173a1ecSIngo WeinholdHOST_HAIKU_PORTER=
454e173a1ecSIngo WeinholdHAIKU_PORTS=
455e173a1ecSIngo WeinholdHAIKU_PORTS_CROSS=
456e70c4c64SPulkoMandyHAIKU_BOOT_BOARD=
457aa2e5ecaSOliver TappeHAIKU_NO_DOWNLOADS=0
4582a5d0aafSIngo Weinhold
459c0e8cc1aSIngo WeinholdHAIKU_PACKAGING_ARCHS=
460c0e8cc1aSIngo Weinhold
461a04a520bSJonathan Schleiferset_default_value HAIKU_NASM		nasm
462c0e8cc1aSIngo Weinhold
4633942ca0dSIngo Weinholdif sha256sum < /dev/null > /dev/null 2>&1; then
4642a5d0aafSIngo Weinhold	HOST_SHA256=sha256sum
4653942ca0dSIngo Weinholdelif sha256 < /dev/null > /dev/null 2>&1; then
4662a5d0aafSIngo Weinhold	HOST_SHA256="sha256 -q"
467b5a871b1SNiels Sascha Reedijkelif shasum < /dev/null > /dev/null 2>&1; then
468b5a871b1SNiels Sascha Reedijk	HOST_SHA256="shasum -a 256"
4692a5d0aafSIngo Weinholdelse
4702a5d0aafSIngo Weinhold	echo "Error: Neither sha256sum nor sha256 seem to be available!" >&2
4712a5d0aafSIngo Weinhold	exit 1
4722a5d0aafSIngo Weinholdfi
473338b8dc3SIngo Weinhold
474410d94cfSOliver TappehaikuRequiredLegacyGCCVersion="2.95.3-haiku-2014_07_26"
475a559f87aSFrançois Revolexport haikuRequiredLegacyGCCVersion
476af4bf973SOliver Tappe	# version of legacy gcc required to build haiku
477483b28e4SIngo WeinholdsupportedTargetArchs="
478483b28e4SIngo Weinhold	arm
479483b28e4SIngo Weinhold	m68k
480483b28e4SIngo Weinhold	ppc
481483b28e4SIngo Weinhold	x86
482483b28e4SIngo Weinhold	x86_64
483483b28e4SIngo Weinhold	x86_gcc2
484483b28e4SIngo Weinhold	"
485e70c4c64SPulkoMandysupportedTargetBoards="
486e70c4c64SPulkoMandy	beagle
487c0b833b1SAlexander von Gluck IV	raspberry_pi
488e70c4c64SPulkoMandy	verdex
489e70c4c64SPulkoMandy	"
490af4bf973SOliver Tappe
4917c4641d0SOliver Tappe# determine output directory
4927c4641d0SOliver Tappeif [ "$currentDir" = "$sourceDir" ]; then
4937c4641d0SOliver Tappe	outputDir=$currentDir/generated
4947c4641d0SOliver Tappeelse
4957c4641d0SOliver Tappe	outputDir=$currentDir
4967c4641d0SOliver Tappefi
4977c4641d0SOliver TappebuildOutputDir="$outputDir/build"
4987c4641d0SOliver TappeHAIKU_BUILD_ATTRIBUTES_DIR="$outputDir/attributes"
4997c4641d0SOliver TappebuildConfigFile="$buildOutputDir/BuildConfig"
5007c4641d0SOliver Tappe
5017c4641d0SOliver Tappe# check for update request
5027c4641d0SOliver Tappeif [ "$1" = "--update" ]; then
5037c4641d0SOliver Tappe	if ! [ -e "$buildConfigFile" ]; then
5047c4641d0SOliver Tappe		echo $0 --update: \'$buildConfigFile\' not found - updating not possible.
5057c4641d0SOliver Tappe		exit 1
5067c4641d0SOliver Tappe	fi
5077c4641d0SOliver Tappe	if ! type perl >/dev/null 2>&1; then
5087c4641d0SOliver Tappe		echo $0 --update: \'perl\' not found - updating not possible.
5097c4641d0SOliver Tappe		exit 1
5107c4641d0SOliver Tappe	fi
5117c4641d0SOliver Tappe	# convert BuildConfig from jam format to shell format and evaluate it
5127c4641d0SOliver Tappe	shellConfigFile="${buildConfigFile}.shell"
5137c4641d0SOliver Tappe	perl "$sourceDir/build/scripts/convert_build_config_to_shell_format.pl" \
5147c4641d0SOliver Tappe		<"$buildConfigFile" >"$shellConfigFile"
5157c4641d0SOliver Tappe	. "$shellConfigFile"
5167c4641d0SOliver Tappe	rm "$shellConfigFile"
5177c4641d0SOliver Tappe	shift
5187c4641d0SOliver Tappefi
5197c4641d0SOliver Tappe
520022fa244SIngo Weinhold# parse parameters
521022fa244SIngo Weinhold#
52220ab75e6SIngo Weinholdwhile [ $# -gt 0 ] ; do
523022fa244SIngo Weinhold	case "$1" in
524e173a1ecSIngo Weinhold		--bootstrap)
525e173a1ecSIngo Weinhold			assertparams "$1" 3 $#
526e173a1ecSIngo Weinhold			HOST_HAIKU_PORTER="`absolute_path $2`"
527e173a1ecSIngo Weinhold			HAIKU_PORTS_CROSS="`absolute_path $3`"
528e173a1ecSIngo Weinhold			HAIKU_PORTS="`absolute_path $4`"
529502882dbSJessica Hamilton			check_file_exists "$HOST_HAIKU_PORTER" || (
530502882dbSJessica Hamilton				echo "Invalid path to haikuporter: $HOST_HAIKU_PORTER" >&2
53139d444a3SArvind S Raj				exit 1
53239d444a3SArvind S Raj			)
53339d444a3SArvind S Raj			check_dir_exists "$HAIKU_PORTS" || (
53439d444a3SArvind S Raj				echo "Non-existent directory $HAIKU_PORTS" >&2
53539d444a3SArvind S Raj				exit 1
53639d444a3SArvind S Raj			)
53739d444a3SArvind S Raj			check_dir_exists "$HAIKU_PORTS_CROSS" || (
53839d444a3SArvind S Raj				echo "Non-existent directory $HAIKU_PORTS_CROSS" >&2
53939d444a3SArvind S Raj				exit 1
54039d444a3SArvind S Raj			)
541e173a1ecSIngo Weinhold			shift 4
542e173a1ecSIngo Weinhold			;;
543c0e8cc1aSIngo Weinhold		--build-cross-tools)
544c0e8cc1aSIngo Weinhold			if [ -z "$buildCrossTools" ]; then
5459b0dd528SIngo Weinhold				assertparams "$1" 2 $#
546c0e8cc1aSIngo Weinhold				targetArch=$2
5479b0dd528SIngo Weinhold				buildCrossTools=$3
5489b0dd528SIngo Weinhold				shift 3
549c0e8cc1aSIngo Weinhold			else
550c0e8cc1aSIngo Weinhold				assertparam "$1" $#
551c0e8cc1aSIngo Weinhold				targetArch=$2
552c0e8cc1aSIngo Weinhold				shift 2
553c0e8cc1aSIngo Weinhold			fi
554c0e8cc1aSIngo Weinhold			case "$targetArch" in
555c0e8cc1aSIngo Weinhold				x86_gcc2)	targetMachine=i586-pc-haiku;;
556c0e8cc1aSIngo Weinhold				x86)		targetMachine=i586-pc-haiku;;
557c0e8cc1aSIngo Weinhold				x86_64)		targetMachine=x86_64-unknown-haiku;;
558c0e8cc1aSIngo Weinhold				ppc)		targetMachine=powerpc-apple-haiku;;
559c0e8cc1aSIngo Weinhold				m68k)		targetMachine=m68k-unknown-haiku;;
560c0e8cc1aSIngo Weinhold				arm)		targetMachine=arm-unknown-haiku;;
561c0e8cc1aSIngo Weinhold				*)
562c0e8cc1aSIngo Weinhold					echo "Unsupported target architecture: $2" >&2
563c0e8cc1aSIngo Weinhold					exit 1
564c0e8cc1aSIngo Weinhold					;;
565c0e8cc1aSIngo Weinhold			esac
566c0e8cc1aSIngo Weinhold			set_variable buildCrossToolsMachine_$targetArch $targetMachine
567c0e8cc1aSIngo Weinhold			targetArchs="$targetArchs $targetArch"
568c0e8cc1aSIngo Weinhold			HAIKU_PACKAGING_ARCHS=
5699b0dd528SIngo Weinhold			;;
5709b0dd528SIngo Weinhold		--cross-tools-prefix)
5719b0dd528SIngo Weinhold			assertparam "$1" $#
572c0e8cc1aSIngo Weinhold			targetArch=unknown${unknownArchIndex}
573c0e8cc1aSIngo Weinhold			set_variable crossToolsPrefix_$targetArch "$2"
574c0e8cc1aSIngo Weinhold			targetArchs="$targetArchs $targetArch"
575c0e8cc1aSIngo Weinhold			HAIKU_PACKAGING_ARCHS=
576d68208faSMatt Madia			unknownArchIndex=$(($unknownArchIndex + 1))
5779b0dd528SIngo Weinhold			shift 2
5789b0dd528SIngo Weinhold			;;
579a66c32ddSIngo Weinhold		--distro-compatibility)
5809b0dd528SIngo Weinhold			assertparam "$1" $#
5817c4641d0SOliver Tappe			HAIKU_DISTRO_COMPATIBILITY=$2
5827c4641d0SOliver Tappe			case "$HAIKU_DISTRO_COMPATIBILITY" in
583a66c32ddSIngo Weinhold				official)	;;
584a66c32ddSIngo Weinhold				compatible)	;;
585a66c32ddSIngo Weinhold				default)	;;
586a66c32ddSIngo Weinhold				*)			echo "Invalid distro compatibility" \
5877c4641d0SOliver Tappe								"level: $HAIKU_DISTRO_COMPATIBILITY"
588a66c32ddSIngo Weinhold							exit 1;;
589a66c32ddSIngo Weinhold			esac
5909b0dd528SIngo Weinhold			shift 2
5919b0dd528SIngo Weinhold			;;
5927c4641d0SOliver Tappe		--enable-multiuser)	HAIKU_ENABLE_MULTIUSER=1; shift 1;;
5932ebcd86dSIngo Weinhold		--host-only)	HAIKU_HOST_BUILD_ONLY=1; shift 1;;
5947c4641d0SOliver Tappe		--include-gpl-addons)	HAIKU_INCLUDE_GPL_ADDONS=1; shift 1;;
5957c4641d0SOliver Tappe		--include-patented-code)	HAIKU_INCLUDE_PATENTED_CODE=1; shift 1;;
59676fa0be3SIngo Weinhold		--include-sources)	HAIKU_INCLUDE_SOURCES=1; shift 1;;
5977c4641d0SOliver Tappe		--include-3rdparty)	HAIKU_INCLUDE_3RDPARTY=1; shift 1;;
59860d8d8fcSIngo Weinhold        -j*)				buildCrossToolsJobs="$1"; shift 1;;
599aa2e5ecaSOliver Tappe		--no-downloads)	HAIKU_NO_DOWNLOADS=1; shift 1;;
6007c4641d0SOliver Tappe		--target=*)     TARGET_PLATFORM=`echo $1 | cut -d'=' -f2-`; shift 1;;
601483b28e4SIngo Weinhold		--target-arch)
602483b28e4SIngo Weinhold			assertparam "$1" $#
603483b28e4SIngo Weinhold			targetArch=$2
604483b28e4SIngo Weinhold			shift 2
605483b28e4SIngo Weinhold			if [ ! "$platform" = Haiku ]; then
606483b28e4SIngo Weinhold				echo "--target-arch can only be specified on Haiku." >&2
607483b28e4SIngo Weinhold				exit 1
608483b28e4SIngo Weinhold			fi
609483b28e4SIngo Weinhold			is_in_list "$targetArch" "$supportedTargetArchs" || (
610483b28e4SIngo Weinhold				echo "Unsupported target architecture: \"$targetArch\"" >&2
611483b28e4SIngo Weinhold				exit 1
612483b28e4SIngo Weinhold			)
613483b28e4SIngo Weinhold			haikuTargetArchs="$haikuTargetArchs $targetArch"
614483b28e4SIngo Weinhold			;;
615e70c4c64SPulkoMandy		--target-board)
616e70c4c64SPulkoMandy			assertparam "$1" $#
617e70c4c64SPulkoMandy			HAIKU_BOOT_BOARD=$2
618e70c4c64SPulkoMandy			is_in_list "$HAIKU_BOOT_BOARD" "$supportedTargetBoards" || (
619e70c4c64SPulkoMandy				echo "Unsupported target board: \"$HAIKU_BOOT_BOARD\"" >&2
620e70c4c64SPulkoMandy				exit 1
621e70c4c64SPulkoMandy			)
622e70c4c64SPulkoMandy			shift 2
623e70c4c64SPulkoMandy			;;
624c2b76f7fSJonathan Schleifer		--use-clang) useClang=1; shift 1;;
6257c4641d0SOliver Tappe		--use-gcc-pipe)	HAIKU_USE_GCC_PIPE=1; shift 1;;
626c0e8cc1aSIngo Weinhold		--use-gcc-graphite)	useGccGraphiteDefault=1; shift 1;;
6277986925fSIngo Weinhold		--use-32bit)	HAIKU_HOST_USE_32BIT=1; shift 1;;
6287986925fSIngo Weinhold		--use-xattr)	HAIKU_HOST_USE_XATTR=1; shift 1;;
629bc96e8f3SIngo Weinhold		--use-xattr-ref)	HAIKU_HOST_USE_XATTR_REF=1; shift 1;;
630022fa244SIngo Weinhold		*)				echo Invalid argument: \`$1\'; exit 1;;
631022fa244SIngo Weinhold	esac
632022fa244SIngo Weinholddone
633022fa244SIngo Weinhold
6340df3cc9cSIngo Weinhold# detect the build platform
635338b8dc3SIngo Weinholdcase "${platform}" in
6367c4641d0SOliver Tappe	Darwin)	HOST_PLATFORM=darwin ;;
6377c4641d0SOliver Tappe	FreeBSD)	HOST_PLATFORM=freebsd
638c505b276SFrançois Revol				SFDISK_BINARY=sfdisk-linux
6397986925fSIngo Weinhold				if [ "$HAIKU_HOST_USE_32BIT" = 1 ] ; then
6405abd9a46SIngo Weinhold					echo Unsupported platform: FreeBSD ${platformMachine}
641308c212cSIngo Weinhold					exit 1
642308c212cSIngo Weinhold				fi	;;
6437c4641d0SOliver Tappe	Haiku)	HOST_PLATFORM=haiku_host ;;
6447c4641d0SOliver Tappe	Linux)	HOST_PLATFORM=linux ;;
6457c4641d0SOliver Tappe	OpenBSD) HOST_PLATFORM=openbsd ;;
6467c4641d0SOliver Tappe	SunOS)	HOST_PLATFORM=sunos ;;
6477c4641d0SOliver Tappe	CYGWIN_NT-*) HOST_PLATFORM=cygwin ;;
648338b8dc3SIngo Weinhold	*)		echo Unsupported platform: ${platform}
6494cbe4925SAxel Dörfler			exit 1 ;;
6504cbe4925SAxel Dörfleresac
65152a38012Sejakowatz
652c505b276SFrançois Revol# check common locations for sfdisk
653c505b276SFrançois Revolfor sfdiskDir in /sbin /usr/sbin /usr/local/sbin ; do
654c505b276SFrançois Revol	if [ -e ${sfdiskDir}/${SFDISK_BINARY} ]; then
655c505b276SFrançois Revol		HOST_SFDISK=${sfdiskDir}/${SFDISK_BINARY}
656c505b276SFrançois Revol	fi
657c505b276SFrançois Revoldone
658c505b276SFrançois Revol
6590962132cSAlex Smith# check for case-sensitive filesystem
6600962132cSAlex Smithmkdir haikuCaseTest 2>/dev/null
6610962132cSAlex Smithmkdir haikucasetest 2>/dev/null
6620962132cSAlex SmithcaseInsensitive=$?
66397f5a0bdSAlex Smithrmdir haikuCaseTest haikucasetest 2>/dev/null
6640962132cSAlex Smithif [ $caseInsensitive != 0 ]; then
6653ecc5287SMichael Lotz	echo "You need a case-sensitive file-system to build Haiku."
6660962132cSAlex Smith	if [ $HOST_PLATFORM = "darwin" ]; then
6670962132cSAlex Smith		echo "You can create a case-sensitive disk image using Disk Utility and use"
6680962132cSAlex Smith		echo "it to store the Haiku sources on."
6693ecc5287SMichael Lotz	fi
6700962132cSAlex Smith	exit 1
6713ecc5287SMichael Lotzfi
6723ecc5287SMichael Lotz
673f04f7042SNiels Sascha Reedijk# determine how to invoke sed with extended regexp support for non-GNU sed
674f04f7042SNiels Sascha Reedijkif [ $HOST_PLATFORM = "darwin" ]; then
675f04f7042SNiels Sascha Reedijk	HOST_EXTENDED_REGEX_SED="sed -E"
676f04f7042SNiels Sascha Reedijkfi
677f04f7042SNiels Sascha Reedijk
678338b8dc3SIngo Weinhold# create output directory
6796e7c6fe5SIngo Weinholdmkdir -p "$buildOutputDir" || exit 1
680338b8dc3SIngo Weinhold
6812ebcd86dSIngo Weinholdif [ "$HAIKU_HOST_BUILD_ONLY" = 1 ]; then
6822ebcd86dSIngo Weinhold	invalidCommand=$sourceDir/build/scripts/host_build_only
6832ebcd86dSIngo Weinhold	HAIKU_AR=$invalidCommand
6842ebcd86dSIngo Weinhold	HAIKU_CC=$invalidCommand
6852ebcd86dSIngo Weinhold	HAIKU_LD=$invalidCommand
6862ebcd86dSIngo Weinhold	HAIKU_OBJCOPY=$invalidCommand
6872ebcd86dSIngo Weinhold	HAIKU_RANLIB=$invalidCommand
6882ebcd86dSIngo Weinhold	HAIKU_ELFEDIT=$invalidCommand
689d6f80927SJonathan Schleifer	HAIKU_NASM=$invalidCommand
6902ebcd86dSIngo Weinhold	HAIKU_STRIP=$invalidCommand
6912ebcd86dSIngo Weinholdelse
692c0e8cc1aSIngo Weinhold	if [ -n "$HAIKU_PACKAGING_ARCHS" ]; then
693c0e8cc1aSIngo Weinhold		targetArchs="$HAIKU_PACKAGING_ARCHS"
694c0e8cc1aSIngo Weinhold	fi
695c0e8cc1aSIngo Weinhold	HAIKU_PACKAGING_ARCHS=
696c0e8cc1aSIngo Weinhold
697483b28e4SIngo Weinhold	# On Haiku determine target architectures and tools automatically.
698c0e8cc1aSIngo Weinhold	if [ -z "$targetArchs" ]; then
699483b28e4SIngo Weinhold		if [ $HOST_PLATFORM != haiku_host ]; then
700483b28e4SIngo Weinhold			echo "Please specify the build tools to use or build (via" \
701eaef83a9SJeroen Oortwijn				"--cross-tools-prefix or --build-cross-tools) or specify a" \
702483b28e4SIngo Weinhold				"host-only build (--host-only)." >&2
703483b28e4SIngo Weinhold			exit 1
704483b28e4SIngo Weinhold		fi
705483b28e4SIngo Weinhold
706483b28e4SIngo Weinhold		# determine primary architecture
707dda53eaeSIngo Weinhold		targetArch=`package list -i /system/packages/haiku-*.hpkg \
708483b28e4SIngo Weinhold			| sed '/^\s*architecture:/!d; s,^\s*architecture:\s*,,'`
709483b28e4SIngo Weinhold		is_in_list "$targetArch" "$supportedTargetArchs" || (
710483b28e4SIngo Weinhold			echo "Unsupported target architecture: \"$targetArch\"" >&2
711483b28e4SIngo Weinhold			exit 1
712483b28e4SIngo Weinhold		)
713c0e8cc1aSIngo Weinhold		targetArchs=$targetArch
714483b28e4SIngo Weinhold
715c0e8cc1aSIngo Weinhold		set_default_value HAIKU_AR_$targetArch			ar
716c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CC_$targetArch			gcc
717c0e8cc1aSIngo Weinhold		set_default_value HAIKU_LD_$targetArch			ld
718c0e8cc1aSIngo Weinhold		set_default_value HAIKU_OBJCOPY_$targetArch		objcopy
719c0e8cc1aSIngo Weinhold		set_default_value HAIKU_RANLIB_$targetArch		ranlib
720c0e8cc1aSIngo Weinhold		set_default_value HAIKU_ELFEDIT_$targetArch		elfedit
721c0e8cc1aSIngo Weinhold		set_default_value HAIKU_STRIP_$targetArch		strip
722483b28e4SIngo Weinhold
723483b28e4SIngo Weinhold		# determine secondary architectures
724483b28e4SIngo Weinhold		for targetArch in $supportedTargetArchs; do
72580262a91SMatt Madia			if [ -e /system/packages/haiku_$targetArch-*.hpkg ]; then
726483b28e4SIngo Weinhold				targetArchs="$targetArchs $targetArch"
727483b28e4SIngo Weinhold				set_default_value HAIKU_AR_$targetArch		ar-$targetArch
728483b28e4SIngo Weinhold				set_default_value HAIKU_CC_$targetArch		gcc-$targetArch
729483b28e4SIngo Weinhold				set_default_value HAIKU_LD_$targetArch		ld-$targetArch
730483b28e4SIngo Weinhold				set_default_value HAIKU_OBJCOPY_$targetArch	objcopy-$targetArch
731483b28e4SIngo Weinhold				set_default_value HAIKU_RANLIB_$targetArch	ranlib-$targetArch
732483b28e4SIngo Weinhold				set_default_value HAIKU_ELFEDIT_$targetArch	elfedit-$targetArch
733483b28e4SIngo Weinhold				set_default_value HAIKU_STRIP_$targetArch	strip-$targetArch
734483b28e4SIngo Weinhold			fi
735483b28e4SIngo Weinhold		done
736483b28e4SIngo Weinhold
737483b28e4SIngo Weinhold		# The target architectures might have been specified explicitly.
738483b28e4SIngo Weinhold		if [ -n "$haikuTargetArchs" ]; then
739483b28e4SIngo Weinhold			for targetArch in $haikuTargetArchs; do
740483b28e4SIngo Weinhold				is_in_list "$targetArch" "$targetArchs" || (
741483b28e4SIngo Weinhold					echo "Unsupported target architecture: \"$targetArch\"." \
742483b28e4SIngo Weinhold						"Only native architectures of the host platform can" \
743483b28e4SIngo Weinhold						"be specified." >&2
744483b28e4SIngo Weinhold					exit 1
745483b28e4SIngo Weinhold				)
746483b28e4SIngo Weinhold			done
747483b28e4SIngo Weinhold			targetArchs="$haikuTargetArchs"
748483b28e4SIngo Weinhold		fi
749c0e8cc1aSIngo Weinhold	fi
750c0e8cc1aSIngo Weinhold
75168ccc989SIngo Weinhold	isPrimaryArch=1
752c0e8cc1aSIngo Weinhold	for targetArch in $targetArchs; do
753c0e8cc1aSIngo Weinhold		# Note: targetArch is "unknown<n>" at this point, if a cross-tools
754c0e8cc1aSIngo Weinhold		# prefix was specified. The standard_gcc_settings call below will get
755c0e8cc1aSIngo Weinhold		# the actual architecture.
756c0e8cc1aSIngo Weinhold
757c0e8cc1aSIngo Weinhold		crossToolsPrefix=`get_variable crossToolsPrefix_$targetArch`
758c0e8cc1aSIngo Weinhold
759338b8dc3SIngo Weinhold		# build cross tools from sources
760c0e8cc1aSIngo Weinhold		if [ -n "$buildCrossTools" -a -z "$crossToolsPrefix" ]; then
761c0e8cc1aSIngo Weinhold			crossToolsDir="$outputDir/cross-tools-$targetArch"
762c0e8cc1aSIngo Weinhold			targetMachine=`get_variable buildCrossToolsMachine_$targetArch`
763c0e8cc1aSIngo Weinhold			script="$buildCrossToolsScript"
7648304ec7cSIngo Weinhold			scriptArgs=
765c0e8cc1aSIngo Weinhold			if [ $targetArch != x86_gcc2 ]; then
7668304ec7cSIngo Weinhold				script="${script}_gcc4"
7678304ec7cSIngo Weinhold				scriptArgs="$targetMachine"
7681e93288eSJérôme Duval				set_default_value HAIKU_USE_GCC_GRAPHITE_$targetArch	\
7691e93288eSJérôme Duval					$useGccGraphiteDefault
770c0e8cc1aSIngo Weinhold			fi
77168ccc989SIngo Weinhold			secondaryArch=
77268ccc989SIngo Weinhold			if [ -z "$isPrimaryArch" ]; then
77368ccc989SIngo Weinhold				secondaryArch=$targetArch
77468ccc989SIngo Weinhold			fi
77586de8c37SIngo Weinhold
77686de8c37SIngo Weinhold			case $HOST_PLATFORM in
77786de8c37SIngo Weinhold				freebsd|openbsd)	MAKE=gmake;;
77886de8c37SIngo Weinhold				*)					MAKE=make;;
77986de8c37SIngo Weinhold			esac
78086de8c37SIngo Weinhold
78186de8c37SIngo Weinhold			MAKE=$MAKE \
78268ccc989SIngo Weinhold			SECONDARY_ARCH=$secondaryArch \
783c0e8cc1aSIngo Weinhold			HAIKU_USE_GCC_GRAPHITE=`get_variable \
784c0e8cc1aSIngo Weinhold				HAIKU_USE_GCC_GRAPHITE_$targetArch` \
785b3ece905SJérôme Duval			HAIKU_USE_GCC_PIPE=$HAIKU_USE_GCC_PIPE \
7868304ec7cSIngo Weinhold			"$script" $scriptArgs "$sourceDir" "$buildCrossTools" \
7878304ec7cSIngo Weinhold				"$crossToolsDir" $buildCrossToolsJobs || exit 1
788c0e8cc1aSIngo Weinhold			crossToolsPrefix="$crossToolsDir/bin/${targetMachine}-"
789338b8dc3SIngo Weinhold		fi
790338b8dc3SIngo Weinhold
791c0e8cc1aSIngo Weinhold		# prepare gcc settings and get the actual target architecture
792c0e8cc1aSIngo Weinhold		gcc="${crossToolsPrefix}gcc"
793c0e8cc1aSIngo Weinhold		if [ -z "${crossToolsPrefix}" ]; then
794c0e8cc1aSIngo Weinhold			gcc=`get_variable HAIKU_CC_$targetArch`
795338b8dc3SIngo Weinhold		fi
796c0e8cc1aSIngo Weinhold		standard_gcc_settings "$gcc"
797c0e8cc1aSIngo Weinhold		targetArch=$standard_gcc_settings_targetArch
798338b8dc3SIngo Weinhold
799c0e8cc1aSIngo Weinhold		# set default values for flags
800c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CPPFLAGS_$targetArch	""
801c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CCFLAGS_$targetArch		""
802c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CXXFLAGS_$targetArch	""
803c0e8cc1aSIngo Weinhold		set_default_value HAIKU_LDFLAGS_$targetArch		""
804c0e8cc1aSIngo Weinhold		set_default_value HAIKU_ARFLAGS_$targetArch		cru
805c0e8cc1aSIngo Weinhold		set_default_value HAIKU_UNARFLAGS_$targetArch	x
806338b8dc3SIngo Weinhold
807c0e8cc1aSIngo Weinhold		# Override the cross tools variables, if the tools were built or a
808c0e8cc1aSIngo Weinhold		# prefix was specified.
809b7777272SAlex Smith		if [ -n "$crossToolsPrefix" ]; then
810c0e8cc1aSIngo Weinhold			get_build_tool_path AR_$targetArch ${crossToolsPrefix}ar
811c0e8cc1aSIngo Weinhold			get_build_tool_path LD_$targetArch ${crossToolsPrefix}ld
812c0e8cc1aSIngo Weinhold			get_build_tool_path OBJCOPY_$targetArch ${crossToolsPrefix}objcopy
813c0e8cc1aSIngo Weinhold			get_build_tool_path RANLIB_$targetArch ${crossToolsPrefix}ranlib
814c0e8cc1aSIngo Weinhold			get_build_tool_path STRIP_$targetArch ${crossToolsPrefix}strip
815c0e8cc1aSIngo Weinhold
816c0e8cc1aSIngo Weinhold			case `get_variable HAIKU_GCC_RAW_VERSION_$targetArch` in
817bd16f0ddSAlex Smith				4.*)
818c0e8cc1aSIngo Weinhold					get_build_tool_path ELFEDIT_$targetArch \
819c0e8cc1aSIngo Weinhold						${crossToolsPrefix}elfedit
820bd16f0ddSAlex Smith				;;
821bd16f0ddSAlex Smith			esac
82252a38012Sejakowatz		fi
82352a38012Sejakowatz
824ef57df3dSIngo Weinhold		# check whether the Haiku compiler really targets Haiku
825c0e8cc1aSIngo Weinhold		targetMachine=`get_variable HAIKU_GCC_MACHINE_$targetArch`
826c0e8cc1aSIngo Weinhold		case "$targetMachine" in
827eedc3d0bSIngo Weinhold			*-*-haiku)	;;
828c0e8cc1aSIngo Weinhold			*)
829c0e8cc1aSIngo Weinhold				echo The compiler specified as Haiku target compiler is not a \
830c0e8cc1aSIngo Weinhold				valid Haiku cross-compiler. Please see ReadMe.cross-compile. >&2
831eedc3d0bSIngo Weinhold				echo compiler: $HAIKU_CC
832c0e8cc1aSIngo Weinhold				echo compiler is configured for target: $targetMachine
833eedc3d0bSIngo Weinhold				exit 1 ;;
834eedc3d0bSIngo Weinhold		esac
835c0e8cc1aSIngo Weinhold
836c0e8cc1aSIngo Weinhold		HAIKU_PACKAGING_ARCHS="$HAIKU_PACKAGING_ARCHS $targetArch"
83768ccc989SIngo Weinhold		isPrimaryArch=
838c0e8cc1aSIngo Weinhold	done
8392ebcd86dSIngo Weinholdfi
840eedc3d0bSIngo Weinhold
84152a38012Sejakowatz# Generate BuildConfig
8427c4641d0SOliver Tappecat << EOF > "$buildConfigFile"
84352a38012Sejakowatz# BuildConfig
844ab2540c4SIngo Weinhold# Note: This file has been automatically generated by configure with the
845ab2540c4SIngo Weinhold# following arguments:
84655d267a4SFrançois Revol# ${configureArgs}
84752a38012Sejakowatz
8487c4641d0SOliver TappeTARGET_PLATFORM 			?= "${TARGET_PLATFORM}" ;
8497c4641d0SOliver TappeHOST_PLATFORM				?= "${HOST_PLATFORM}" ;
850338b8dc3SIngo Weinhold
8517c4641d0SOliver TappeHAIKU_INCLUDE_GPL_ADDONS			?= "${HAIKU_INCLUDE_GPL_ADDONS}" ;
8527c4641d0SOliver TappeHAIKU_INCLUDE_PATENTED_CODE			?= "${HAIKU_INCLUDE_PATENTED_CODE}" ;
85376fa0be3SIngo WeinholdHAIKU_INCLUDE_SOURCES				?= "${HAIKU_INCLUDE_SOURCES}" ;
8547c4641d0SOliver TappeHAIKU_INCLUDE_3RDPARTY				?= "${HAIKU_INCLUDE_3RDPARTY}" ;
8557c4641d0SOliver TappeHAIKU_ENABLE_MULTIUSER				?= "${HAIKU_ENABLE_MULTIUSER}" ;
8567c4641d0SOliver TappeHAIKU_DISTRO_COMPATIBILITY			?= "${HAIKU_DISTRO_COMPATIBILITY}" ;
8577c4641d0SOliver TappeHAIKU_USE_GCC_PIPE					?= "${HAIKU_USE_GCC_PIPE}" ;
8587986925fSIngo WeinholdHAIKU_HOST_USE_32BIT				?= "${HAIKU_HOST_USE_32BIT}" ;
8597986925fSIngo WeinholdHAIKU_HOST_USE_XATTR				?= "${HAIKU_HOST_USE_XATTR}" ;
860bc96e8f3SIngo WeinholdHAIKU_HOST_USE_XATTR_REF			?= "${HAIKU_HOST_USE_XATTR_REF}" ;
8612ebcd86dSIngo WeinholdHAIKU_HOST_BUILD_ONLY				?= "${HAIKU_HOST_BUILD_ONLY}" ;
862eccc7665SIngo Weinhold
863c0e8cc1aSIngo WeinholdHAIKU_PACKAGING_ARCHS		?= ${HAIKU_PACKAGING_ARCHS} ;
86465ad1ba3SAlex Smith
865aa2e5ecaSOliver TappeHAIKU_NO_DOWNLOADS			?= "${HAIKU_NO_DOWNLOADS}" ;
866aa2e5ecaSOliver Tappe
8677c4641d0SOliver TappeHAIKU_BUILD_ATTRIBUTES_DIR	?= ${HAIKU_BUILD_ATTRIBUTES_DIR} ;
868338b8dc3SIngo Weinhold
869d6f80927SJonathan SchleiferHAIKU_NASM					?= ${HAIKU_NASM} ;
870e70c4c64SPulkoMandyHAIKU_BOOT_BOARD			?= ${HAIKU_BOOT_BOARD} ;
871338b8dc3SIngo Weinhold
872f04f7042SNiels Sascha ReedijkHOST_EXTENDED_REGEX_SED		?= ${HOST_EXTENDED_REGEX_SED} ;
8737c4641d0SOliver TappeHOST_GCC_RAW_VERSION		?= ${HOST_GCC_RAW_VERSION} ;
8747c4641d0SOliver TappeHOST_GCC_MACHINE			?= ${HOST_GCC_MACHINE} ;
8757c4641d0SOliver TappeHOST_LD						?= ${HOST_GCC_LD} ;
8767c4641d0SOliver TappeHOST_OBJCOPY				?= ${HOST_GCC_OBJCOPY} ;
877c505b276SFrançois RevolHOST_SFDISK					?= ${HOST_SFDISK} ;
8782a5d0aafSIngo WeinholdHOST_SHA256					?= ${HOST_SHA256} ;
8798b5934c9SIngo Weinhold
880e173a1ecSIngo WeinholdHOST_HAIKU_PORTER			?= ${HOST_HAIKU_PORTER} ;
881e173a1ecSIngo WeinholdHAIKU_PORTS					?= ${HAIKU_PORTS} ;
882e173a1ecSIngo WeinholdHAIKU_PORTS_CROSS			?= ${HAIKU_PORTS_CROSS} ;
883e173a1ecSIngo Weinhold
884c4786ea6SlilloEOF
885c4786ea6Slillo
886c0e8cc1aSIngo Weinholdfor targetArch in $HAIKU_PACKAGING_ARCHS; do
887c0e8cc1aSIngo Weinhold	variables="
888c0e8cc1aSIngo Weinhold		HAIKU_GCC_RAW_VERSION		HAIKU_GCC_RAW_VERSION
889c0e8cc1aSIngo Weinhold		HAIKU_GCC_MACHINE			HAIKU_GCC_MACHINE
890c0e8cc1aSIngo Weinhold		HAIKU_GCC_LIB_DIR			HAIKU_GCC_LIB_DIR
891c0e8cc1aSIngo Weinhold		HAIKU_CPU					HAIKU_CPU
892c0e8cc1aSIngo Weinhold		HAIKU_BOOT_LIBGCC			HAIKU_BOOT_LIBGCC
893c0e8cc1aSIngo Weinhold		HAIKU_BOOT_LIBSUPC++		HAIKU_BOOT_LIBSUPCXX
894c0e8cc1aSIngo Weinhold		HAIKU_AR					HAIKU_AR
895c0e8cc1aSIngo Weinhold		HAIKU_CC					HAIKU_CC
896c2b76f7fSJonathan Schleifer		HAIKU_CC_IS_CLANG			HAIKU_CC_IS_CLANG
897c0e8cc1aSIngo Weinhold		HAIKU_LD					HAIKU_LD
898c0e8cc1aSIngo Weinhold		HAIKU_OBJCOPY				HAIKU_OBJCOPY
899c0e8cc1aSIngo Weinhold		HAIKU_RANLIB				HAIKU_RANLIB
900c0e8cc1aSIngo Weinhold		HAIKU_ELFEDIT				HAIKU_ELFEDIT
901c0e8cc1aSIngo Weinhold		HAIKU_STRIP					HAIKU_STRIP
902c0e8cc1aSIngo Weinhold		HAIKU_CPPFLAGS				HAIKU_CPPFLAGS
903c0e8cc1aSIngo Weinhold		HAIKU_CCFLAGS				HAIKU_CCFLAGS
904c0e8cc1aSIngo Weinhold		HAIKU_C++FLAGS				HAIKU_CXXFLAGS
905c0e8cc1aSIngo Weinhold		HAIKU_LDFLAGS				HAIKU_LDFLAGS
906c0e8cc1aSIngo Weinhold		HAIKU_ARFLAGS				HAIKU_ARFLAGS
907c0e8cc1aSIngo Weinhold		HAIKU_UNARFLAGS				HAIKU_UNARFLAGS
908c0e8cc1aSIngo Weinhold		HAIKU_USE_GCC_GRAPHITE		HAIKU_USE_GCC_GRAPHITE
909c0e8cc1aSIngo Weinhold		"
910c0e8cc1aSIngo Weinhold	set -- $variables
911c0e8cc1aSIngo Weinhold	while [ $# -ge 2 ]; do
912c0e8cc1aSIngo Weinhold		value=`get_variable ${2}_$targetArch`
913c0e8cc1aSIngo Weinhold		echo "${1}_${targetArch} ?= $value ;" >> "$buildConfigFile"
914c0e8cc1aSIngo Weinhold		shift 2
915c0e8cc1aSIngo Weinhold	done
916b1e5b60cSAxel Dörfler
917c0e8cc1aSIngo Weinhold	# For variables that may have long values, distribute them over multiple
918c0e8cc1aSIngo Weinhold	# lines so that jam doesn't hit the maximum line length.
919c0e8cc1aSIngo Weinhold	variables="
92066a7f29fSJérôme Duval		HAIKU_BOOT_C++_HEADERS_DIR	HAIKU_BOOT_CXX_HEADERS_DIR
921c0e8cc1aSIngo Weinhold		"
922c0e8cc1aSIngo Weinhold	set -- $variables
923c0e8cc1aSIngo Weinhold	while [ $# -ge 2 ]; do
924c0e8cc1aSIngo Weinhold		echo "${1}_${targetArch} ?= " >> "$buildConfigFile"
925c0e8cc1aSIngo Weinhold		get_variable ${2}_$targetArch | xargs -n 1 echo "   " \
926c0e8cc1aSIngo Weinhold			>> "$buildConfigFile"
927c0e8cc1aSIngo Weinhold		echo "    ;" >> "$buildConfigFile"
928c0e8cc1aSIngo Weinhold		shift 2
929c0e8cc1aSIngo Weinhold	done
930c0e8cc1aSIngo Weinholddone
931b1e5b60cSAxel Dörfler
932b1e5b60cSAxel Dörfler
9339b0dd528SIngo Weinhold# Generate a boot strap Jamfile in the output directory.
934338b8dc3SIngo Weinhold
935338b8dc3SIngo Weinholdcat << EOF > $outputDir/Jamfile
936338b8dc3SIngo Weinhold# automatically generated Jamfile
937338b8dc3SIngo Weinhold
938338b8dc3SIngo WeinholdHAIKU_TOP			= ${sourceDir} ;
939338b8dc3SIngo WeinholdHAIKU_OUTPUT_DIR	= ${outputDir} ;
940338b8dc3SIngo Weinhold
941338b8dc3SIngo Weinholdinclude [ FDirName \$(HAIKU_TOP) Jamfile ] ;
942338b8dc3SIngo Weinhold
943338b8dc3SIngo WeinholdEOF
944